---
title: WeakSet() constructor
slug: Web/JavaScript/Reference/Global_Objects/WeakSet/WeakSet
tags:
  - Constructor
  - JavaScript
  - Reference
  - WeakSet
---
<div>{{JSRef}}</div>

<p>The <strong><code>WeakSet</code></strong> constructor lets you create <code>WeakSet</code> objects that store weakly held <em>objects</em> in a collection.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">new WeakSet([<var>iterable</var>]);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><var>iterable</var></dt>
 <dd>If an <a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of">iterable object</a> is passed, all of its elements will be added to the new <code>WeakSet</code>. null is treated as undefined.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_the_WeakSet_object">Using the WeakSet object</h3>

<pre class="brush: js notranslate">var ws = new WeakSet();
var foo = {};
var bar = {};

ws.add(foo);
ws.add(bar);

ws.has(foo);    // true
ws.has(bar);    // true

ws.delete(foo); // removes foo from the set
ws.has(foo);    // false, foo has been removed
ws.has(bar);    // true, bar is retained</pre>

<p>Note that <code>foo !== bar</code>. While they are similar objects, <em>they are not <strong>the same object</strong></em>. And so they are both added to the set.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-weakset-constructor', 'WeakSet constructor')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.WeakSet.WeakSet")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("WeakSet")}}</li>
</ul>
